# Adjustment Reports When creating a shipment you are required to provide the total weight of your packages. Rates are provided to you based on the weight you enter. If the weight you provide and the actual weight are different, then carriers update the rate amount and credit or debit your account with the new rate charge. The [USPS APV Program](https://www.usps.com/business/verify-postage.htm) and [GP/GAP](https://stamps.custhelp.com/app/answers/detail/a_id/5189/~/introducing-global-advantage-program) (Global Post/Global Advantage Program) allows us to provide you with itemized insight into which shipping items caused the charges or refunds to your account balance. New reports are generated on a nightly basis. ## Report Endpoints You can access your cost adjustment reports via the following endpoints: - `/v1/incubator/adjustments/reports/` - `/v1/incubator/adjustments/reports/{report_id}` ## List Available Reports The list of available reports can be filtered with the following query parameters: | Query Parameter | Type | Description | | --- | --- | --- | | `created_at_start` | *date string* | Only return reports that were created on or after a specific date/time ([ISO 8601 Standard](https://en.wikipedia.org/wiki/ISO_8601)) ex: `2019-07-25T15:24:46.657Z` | | `created_at_end` | *date string* | Only return reports that were created on or before a specific date/time ([ISO 8601 Standard](https://en.wikipedia.org/wiki/ISO_8601)) ex: `2019-07-25T15:24:46.657Z` | | `page` | *integer* | Return a specific "page" of results. Defaults to the first page. If set to a number that's greater than the number of pages of results, an empty page will be returned. ex. `100` | | `page_size` | *integer* | The number of labels to return per response. Defaults to 25. ex. `100` | | `sort_dir` | *enumerated string* | Controls the sort order of the query. Defaults to `desc`. `asc` or `desc` | | `sort_by` | *enumerated string* | Controls which property the query is sorted by. `modified_at`, `created_at` Defaults to `created_at` | ## Example ```http GET /v1/incubator/adjustments/reports HTTP/1.1 Host: app.shipengine.com ``` ``` { "reports": [ { "report_id": "rpt_7QwpuXmAqPRRSfbX8QbAZ1", "created_at": "2019-09-03T16:04:18.052402-04:00", "report_download": { "href": "https://api.shipengine.com/v1/incubator/adjustments/reports/rpt_7QwpuXmAqPRRSfbX8QbAZ1" } }, { "report_id": "rpt_Xqg2eaygL7i5XzWJuuGENc", "created_at": "2019-10-07T15:15:21.758769-04:00", "report_download": { "href": "https://api.shipengine.com/v1/incubator/adjustments/reports/rpt_Xqg2eaygL7i5XzWJuuGENc" } } ], "total": 2, "page": 1, "pages": 1, "links": { "first": { "href": "https://api.shipengine.com/v1/incubator/adjustments/reports?page=1&page_size=50&sort_dir=asc&sort_by=created_at" }, "last": { "href": "https://api.shipengine.com/v1/incubator/adjustments/reports?page=1&page_size=50&sort_dir=asc&sort_by=created_at" }, "prev": { "href": "https://api.shipengine.com/v1/incubator/adjustments/reports?page=1&page_size=50&sort_dir=asc&sort_by=created_at" }, "next": { "href": "https://api.shipengine.com/v1/incubator/adjustments/reports?page=1&page_size=50&sort_dir=asc&sort_by=created_at" } } } ``` ## Retrieve Individual Reports ```http GET /v1/incubator/adjustments/reports/{report_id} HTTP/1.1 Host: app.shipengine.com ``` ```csv CarrierID,ShipmentID,AdjustmentType,AdjustmentID,TransactionID,ExternalShipmentID,TrackingNumber,ReasonCode,AdjustmentAmount,AdjustmentDate,DisputeStatus,DisputeCreatedAt,DisputeUpdatedAt,ActualTrackingNumber,ActualService,ActualPackage,ActualWeight,ActualLength,ActualWidth,ActualHeight,ActualOriginZip,ActualToZip,ActualCountry,ActualZone,ActualInternationalZone se-194932,se-220074122,GAP,,bd9f1e7d-2d4f-42e1-b0b6-efcbd1b6db26,403-9718334-5502758,LX678053798US,,0.710,2019-06-19 07:46:23.93,,,,LX678053798US,International First Class,Postcard,0.274,0.00,0.00,0.00,,08008,ES,, se-194932,se-220084778,GAP,,572781bd-f52c-46bf-8345-a8917ec8193f,407-9977098-3301963,LX678054802US,,1.070,2019-06-19 07:46:23.867,,,,LX678054802US,International First Class,Postcard,0.338,0.00,0.00,0.00,,20149,IT,, se-194932,se-220085586,GAP,,5c8fdc91-1baf-41a0-adc7-bcbad0b7a221,407-1165026-0025912,LX678054855US,,1.070,2019-06-19 07:46:23.747,,,,LX678054855US,International First Class,Postcard,0.350,0.00,0.00,0.00,,34170,IT,, se-194932,se-220106892,GAP,,d22e13ce-d5c5-4b6e-960e-f36a153ae699,405-9825900-9360313,LX678056729US,,0.340,2019-06-19 07:46:23.51,,,,LX678056729US,International First Class,Postcard,0.248,0.00,0.00,0.00,,89128,IT,, se-194932,se-220106249,GAP,,293cf295-3ac7-46dd-8ce8-3c70bbce62e7,406-4443199-4692349,LX678056692US,,0.710,2019-06-19 07:46:23.263,,,,LX678056692US,International First Class,Postcard,0.280,0.00,0.00,0.00,,49124,FR,, se-194932,se-220106133,GAP,,46627b13-d7a8-4040-adbb-96c9aceba6b5,402-6135486-2025927,LX678056675US,,0.340,2019-06-19 07:46:22.993,,,,LX678056675US,International First Class,Postcard,0.232,0.00,0.00,0.00,,24126,IT,, se-194932,se-220105026,GAP,,c7cc0d76-91ca-4f3a-aa92-29be1cf1ccb8,206-5718974-6791531,LX678056542US,,0.720,2019-06-19 07:46:22.93,,,,LX678056542US,International First Class,Postcard,0.150,0.00,0.00,0.00,,ME14 2AU,GB,, se-194932,se-220103277,GAP,,4290de02-b97b-4ff4-b0ca-aab2087ede21,026-1881690-4479549,LX678056445US,,0.340,2019-06-19 07:46:22.87,,,,LX678056445US,International First Class,Postcard,0.210,0.00,0.00,0.00,,HA4 6SY,GB,, se-194932,se-220100680,GAP,,2cc3df36-8679-4a6a-86d8-84a4d097196d,306-4120817-1421140,LX678056247US,,0.340,2019-06-19 07:46:22.82,,,,LX678056247US,International First Class,Postcard,0.250,0.00,0.00,0.00,,13585,DE,, se-194932,se-220100132,GAP,,7e1f4c73-faf2-414d-9d61-fcdb81e73a93,406-5878652-3642766,LX678056105US,,0.710,2019-06-19 07:46:22.777,,,,LX678056105US,International First Class,Postcard,0.290,0.00,0.00,0.00,,06950,FR,, se-194932,se-220099901,GAP,,ad9c0fce-7e09-4031-adc5-ba8bb9fd4b6f,305-7237094-2605131,LX678056088US,,1.510,2019-06-19 07:46:22.727,,,,LX678056088US,International First Class,Postcard,0.520,0.00,0.00,0.00,,69214,DE,, se-194932,se-220099562,GAP,,c0d70fe2-5065-40a4-85b4-2e70efa73986,302-5169649-0737965,LX678056065US,,1.780,2019-06-19 07:46:22.677,,,,LX678056065US,International First Class,Postcard,0.440,0.00,0.00,0.00,,88471,DE,, se-194932,se-220099379,GAP,,6a573356-2b90-4b9a-adc2-ae2b0c4db321,028-1527563-2081155,LX678056057US,,1.070,2019-06-19 07:46:22.6,,,,LX678056057US,International First Class,Postcard,0.360,0.00,0.00,0.00,,49828,DE,, se-194932,se-220098506,GAP,,0717c2fd-1ddf-4810-bde6-ae03d4af538f,402-7129924-5017903,LX678055975US,,1.780,2019-06-19 07:46:22.533,,,,LX678055975US,International First Class,Postcard,0.470,0.00,0.00,0.00,,81030,IT,, se-194932,se-220098108,GAP,,b171cf49-2c21-42eb-86bf-04ea06a09c27,026-6433086-9347511,LX678055958US,,0.710,2019-06-19 07:46:22.483,,,,LX678055958US,International First Class,Postcard,0.280,0.00,0.00,0.00,,DE22 4EA,GB,, se-194932,se-220097943,GAP,,d82ac983-a5a4-45e9-9e57-b81e3db6e731,405-6321965-5582767,LX678055944US,,0.340,2019-06-19 07:46:22.44,,,,LX678055944US,International First Class,Postcard,0.250,0.00,0.00,0.00,,10600,ES,, se-194932,se-220097698,GAP,,a8730382-5120-4049-887c-34a38a2f59a5,303-4759563-2469915,LX678055935US,,0.340,2019-06-19 07:46:22.397,,,,LX678055935US,International First Class,Postcard,0.220,0.00,0.00,0.00,,89356,DE,, se-194932,se-220097605,GAP,,eed000f2-f745-4738-ab36-6996f68f1749,302-3101481-3293908,LX678055913US,,0.340,2019-06-19 07:46:22.343,,,,LX678055913US,International First Class,Postcard,0.230,0.00,0.00,0.00,,76698,DE,, se-194932,se-220097223,GAP,,ac8b14ab-b53d-4c2f-9701-ced7d4001d00,405-6184473-9254741,LX678055895US,,5.010,2019-06-19 07:46:22.17,,,,LX678055895US,International First Class,Postcard,1.080,0.00,0.00,0.00,,46220,ES,, se-194932,se-220096444,GAP,,acec3e2f-e4eb-470e-9cae-ade0c4ffb2c7,026-6804533-6165122,LX678055785US,,1.510,2019-06-19 07:46:22.1,,,,LX678055785US,International First Class,Postcard,0.550,0.00,0.00,0.00,,CH3 8NA,GB,, se-194932,se-220096205,GAP,,5f7a128c-92ee-44d4-b19b-c4cbbbc795f8,303-2296607-4377132,LX678055745US,,11.690,2019-06-19 07:46:22.017,,,,LX678055745US,International First Class,Postcard,1.798,0.00,0.00,0.00,,59192,DE,, se-194932,se-220095711,GAP,,b086404a-b120-4056-8092-ffc1bbe3ba4c,406-7291054-6723562,LX678055737US,,0.340,2019-06-19 07:46:21.93,,,,LX678055737US,International First Class,Postcard,0.240,0.00,0.00,0.00,,31290,FR,, se-194932,se-220095377,GAP,,e282e1ca-7c1f-4022-87d1-e3ae3d34bd97,026-1304524-8936364,LX678055697US,,2.990,2019-06-19 07:46:21.887,,,,LX678055697US,International First Class,Postcard,0.916,0.00,0.00,0.00,,LS8 1DH,GB,, se-194932,se-220093479,GAP,,6940c751-b8dc-4479-86f6-6b015e5c5dab,171-2909966-3349165,LX678055621US,,4.770,2019-06-19 07:46:21.643,,,,LX678055621US,International First Class,Postcard,0.848,0.00,0.00,0.00,,04100,FR,, se-194932,se-220091942,GAP,,e8dabf37-7de1-4a19-b0f7-dcc30ed0d1bc,305-3877982-1914764,LX678055459US,,1.070,2019-06-19 07:46:21.557,,,,LX678055459US,International First Class,Postcard,0.328,0.00,0.00,0.00,,81543,DE,, ``` ## Reports Webhook Event Reports can also be retrieved with the `report_complete` [webhook event](/apis/shipengine/docs/guides/webhooks). ### Create Webhook for Reports ```http POST /v1/environment/webhooks HTTP/1.1 Host: api.shipengine.com API-Key: __YOUR_API_KEY_HERE__ SELLER-ID: __YOUR_SELLER_ID_HERE__ Content-Type: application/json { "url": "__YOUR_URL_ENDPOINT_HERE__", "event": "report_complete" } ``` **Webhook Response** ```json { "resource_url": "https://api.shipengine.com/v1/incubator/adjustments/reports/rpt_gGhc2RmYBzGZh", "resource_type": "API_REPORT_COMPLETE", "data": { "report_type": "usps_apv", "created_at": "2019-06-30T15:35:47.173Z", "report_url": { "href": "https://api.shipengine.com/v1/incubator/adjustments/reports/rpt_gGhc2RmYBzGZh" } } } ```